#ifndef COMMON_H
#define COMMON_H

#include <string.h>
#include "queue.h"

#define MAX_PATH	256

#define HEXFMT "0x%08X"
#define LOG(fmt, ...)											\
	pvr_log("%s:%d:" fmt "\n", __PRETTY_FUNCTION__, __LINE__,	\
			##__VA_ARGS__)

int pvr_log( char *fmt, ... ) __attribute__ ((noinline))
	__attribute__((__format__(printf, 1, 2)));

int pvr_log_init(char *fname);
int pvr_log_deinit(void);
int pvr_log_stdout(void);

int strlcpy(char *dst, const char *src, size_t dst_size);
int strlcat(char *dst, const char *src, size_t dst_size);

struct direntry {
	char name[MAX_PATH];
	unsigned char d_type;
	TAILQ_ENTRY(direntry) link;
};
/* struct dirlist */
TAILQ_HEAD(dirlist, direntry);

#define DIRLIST_SORT    0x00000001
#define DIRLIST_DIRONLY 0x00000002
struct dirlist *dirlist_get(char *dir, int flags);
int dirlist_free(struct dirlist *list);

int dir_writable(char *dir);

#endif /* COMMON_H */
