#ifndef CONFIG_H
#define CONFIG_H

#include "common.h"

#define CSTR 256

struct stringlist_entry {
	char value[CSTR];
	TAILQ_ENTRY(stringlist_entry) link;
};

/* struct stringlist; */
TAILQ_HEAD(stringlist, stringlist_entry);

typedef struct
{
	char path[MAX_PATH];
	struct stringlist pvr_target;
	int debug;
	int exedsp_debug;
	unsigned exedsp_facility;
	unsigned exedsp_severity;
	int mod_key;
	int default_source;
	int aspect_ratio;
	int audio_switch;
	int log_keycodes;

	int enable_esaving;
	int esaving_key_check;
	int esaving_key_mute;
	int esaving_key_change;
	int esaving_key_panel_off;

	int enable_pvr;
	#define RECORD_KEYLOCK_DISABLE       0
	#define RECORD_KEYLOCK_ENABLE        1
	#define RECORD_KEYLOCK_ENABLE_LOCKED 2
	#define RECORD_KEYLOCK_NOUNLOCK      3
	int record_key_lock;
	int protect;
	#define CFG_UNICODE_UTF8            0
	#define CFG_UNICODE_ASCII           1
	#define CFG_UNICODE_ASCII_TRANSCODE 2
	int unicode;
	unsigned winter_time;
	unsigned summer_time;
	int show_icons;
	unsigned icon_x;
	unsigned icon_y;
	int testwrite;
	int del_mdb;
	int del_empty_ts;
	unsigned io_buffer;
} cfgstruct;

extern cfgstruct config;

#define CONFIG_FNAME	"pvr.ini"	// configuration file name

int load_config(const char *path);

#endif /* CONFIG_H */
