#ifndef EXEDSP_H

#include <time.h>

struct pvr_rec_set_info {
	char fname[200];
	unsigned xC8;
	unsigned xC4;
	unsigned xC0;
	unsigned xBC;
	unsigned xB8;
	unsigned unk1[3];
	unsigned audio_pid;
	unsigned unk2[2];
	unsigned x9C;
	unsigned video_pid;
	unsigned unk3[4];
	unsigned pcr_pid;
	unsigned unk4;
	unsigned x7C;
	unsigned x70;
	unsigned unk5[2];
	unsigned x64;
	unsigned unk6;
	unsigned x5C;
	unsigned unk7[10];
	unsigned x30;
	unsigned unk8[4];
};

/* PVR functions layer */
int spIPvr_RecOpen(int zero, void **pvr_rec);
int spIPvr_RecSet(void *pvr_rec, struct pvr_rec_set_info *rec_info, int one);
int spIPvr_RecStart(void *pvr_rec);
int spIPvr_Rec_UnregisterCallback(void *pvr_rec, int one);
int spIPvr_RecStop(void *pvr_rec);
int spIPvr_RecClose(void *pvr_rec);
int spIPvr_GetRecInstance(int zero, unsigned **pvr_recinstance);

/* exeDSP internal logging functions */
void spI_SetPrintLevel(unsigned mask);
void spI_SetPrintModule(unsigned module_mask);


struct EPG_datetime {
	unsigned year;
	unsigned month;
	unsigned day;
	unsigned hour;
	unsigned minute;

	unsigned unknown[11];
};
extern unsigned *g_AppTV;
extern void *g_AppWindow;
extern void *g_AppWindowPIP;

void _ZN9TCChannelC1Ev(unsigned *channel);
void _ZN9TCProgramC1Ev(unsigned *program);

int _ZN4TCTv17GetSystemInfoTimeEPmi(void *AppTV, time_t *unixtime,
									int zero);
int _ZN10CTimerUtil10GetSITTimeEPN6PCTime6PTTimeEi(
	struct EPG_datetime *datetime, int zero);
int _ZN8CAppUtil12GetCurrentChEP9TCChanneli(unsigned *channel, int zero);
int _ZN4TCTv17GetPresentProgramEP9TCChanneljP9TCProgram(
	void *AppTV, unsigned *channel, time_t *unixtime, unsigned *program);
int _ZNK9TCProgram8GetTitleEPcPj(unsigned *program, unsigned short *namebuffer,
								 unsigned *namebuflen);

int _ZN10CMovieCore15AudioFormatToTDEN10Multimedia14AudioCodecTypeE(
	int zero, int u8);
int _ZN10CFeeder_CH29locConvertSdalToAvfdAudFormatE15SdAudioFormat_k(
	int zero, int u8);
int spIAvfd_ChangeAudio(int zero, int audio_streamid, int audio_codecid);

/* TCWindow::MuteVideo(bool) */
int _ZN8TCWindow9MuteVideoEb(void **AppWindow, int flag);
#define TCTV_OPTION_ESAVING 0xf
/* TCTv::GetOption(int, int *) */
int _ZN4TCTv9GetOptionEiPi(void *AppTV, int option, unsigned *rval);
/* TCTv::SetOption(int, int) */
int _ZN4TCTv9SetOptionEii(void *AppTV, int option, int val);
/* CApp::SendEvent(PTEvent *, DTV_APPLICATION, bool) */
int _ZN4CApp9SendEventEP7PTEvent15DTV_APPLICATIONb(void *TEvent, int what, int flag);

#endif
