#include "config.h"
#include "mod.h"
#include "mod_keycode.h"

int keycode_init(void)
{
	if (!config.log_keycodes)
		return (MOD_INIT_IGNORE);
	return (MOD_INIT_DONE);
}

int keycode_keypressed(const int *keys, int keys_num, int *key_out)
{
	struct keyinfo *info;
	int key = keys[0];
	int key_orig = key;
	char str_mod[256];
	int modpos = 0;
	struct {
		char ch;
		int flag;
	} mods[] = {
		{'M', MKEY},
		{'T', TKEY},
		{0,      0}
	}, *mod;
	int common_flags = 0;

	for (mod = mods; mod->ch != '\0'; mod++) {
		common_flags |= mod->flag;
		if (!(key & mod->flag))
			continue;
		str_mod[modpos++] = mod->ch;
		str_mod[modpos++] = '+';
	}
	str_mod[modpos] = '\0';

	key &= ~common_flags;
	for (info = keyinfos; info->name != NULL; info++) {
		if (key != info->key)
			continue;
		LOG("Key pressed: [0x%X](%s%s)", key_orig, str_mod, info->name);
		return (MOD_KEYPRESSED_UNKNOWN);
	}
	LOG("Key pressed: [0x%X](%s0x%X)",
		key_orig, str_mod, key);
	return (MOD_KEYPRESSED_UNKNOWN);
}
