/*
 * Get local time from UTC system time function.
 */
#include "timezone.h"

int monthtab[] = {0,31,28,31,30,31,30,31,31,30,31,30,31};

struct tm *get_localtime_from_UTC_sytemtime(int winter_time, int summer_time)
{
  time_t t;
  struct tm *tm;
  t = time(NULL);
  tm = localtime(&t);
   
  if ((winter_time == 0) && (summer_time == 0)) return tm;
     
  int y = tm->tm_year; if (y<1900) y+=1900;
  int month = tm->tm_mon + 1;
  int day   = tm->tm_mday;
  int wday  = tm->tm_wday;
  int hour  = tm->tm_hour;

  int leap = ((y % 4) == 0)? 1:0;
  if ((y % 100) == 0)
     leap = ((y % 400) == 0)?1:0;
  monthtab[2] = 28 + leap;

  int zone = winter_time;
  if ((month) && (month<10)) zone = summer_time;
  else if ((month==3) || (month==10))
  {
     if ((day+8) > monthtab[month])
     {
        if (month==3) 
        {
           zone = summer_time;
           if ((wday==0) && (hour<1)) zone = winter_time;
        }
        if ((month==10) && (wday==0) && (hour<1)) zone = summer_time;
     }
     else
     {
        if (month==10) zone = summer_time;
     }
  }

  hour += zone;
  if (hour > 23)
  {
     hour -= 24;
     wday++;
     if (wday > 6) wday = 0;
     day++;
     if (day > monthtab[month])
     {
        day = 1;
        month++;
        if (month > 12)
        {
           month = 1;
           y++;
           tm->tm_year++;
        }
     }
  }
  else if (hour < 0)
  {
     hour += 24;
     wday--;
     if (wday < 0) wday = 6;
     day--;
     if (day < 1)
     {
        month--;
	if (month < 1)
	{
	   month = 12;
	   y--;
	   tm->tm_year--;
	}
	day = monthtab[month];
     }
  }
  
  tm->tm_wday = wday;
  tm->tm_mon  = month-1;
  tm->tm_mday = day;
  tm->tm_hour = hour;
  return tm;
}

